#ifndef _OS_Memory_H
#define _OS_Memory_H

#include "Prefix.h"
#include <Windows.h>

namespace EARTH {
namespace OS {
	class Memory {
	public:
		enum {
			PAGE_SIZE = (4)*1024
		};

		Memory(uint pageCount)
		{
			mPtr = ::VirtualAlloc(NULL, PAGE_SIZE*pageCount, MEM_COMMIT, PAGE_READWRITE);
		}

		~Memory()
		{
			if (mPtr) {
				BOOL b = ::VirtualFree(mPtr, 0, MEM_RELEASE);
				if (b) {
					mPtr = NULL;
				}
				_ASSERTE(b);
			}
		}

		void *Ptr() const
		{
			return mPtr;
		}

	protected:
		void *mPtr;
	};
}
}

#endif
