#ifndef _TS_Utility_H
#define _TS_Utility_H

#include "Prefix.h"
#include "EARTH_PT.h"

namespace EARTH {
namespace TS {
	static bool Error(const wchar_t *function, status status)
	{
		bool error = (status != PT::STATUS_OK);
		if (error) {
			::wprintf(L"G[܂B%s (0x%08x)\n", function, status);
		}
		return error;
	}

	static int GetNumber(uint maxNumber)
	{
		bool done = false;
		uint number = 0;
		do {
			wint_t wint = ::_getwch();
			if (wint == L'\03') ::exit(-1);

			const wchar_t *string = L"0123456789";
			const wchar_t *ptr = ::wcschr(string, wint);
			if (ptr) {
				number = ptr - string;
				if (number <= maxNumber) {
					::_putch(wint);
					::wprintf(L"\n");
					done = true;
				}
			}
		} while (done == false);

		return number;
	}
}
}

#endif
